[PATCH v2 1/3] scripts,ipkg-build: apply shellcheck

Paul Spooren mail at aparcar.org
Thu Feb 4 18:59:21 EST 2021


This commit cleans the `ipkg-build` script via changes suggested by
shellcheck. These are mostly word splitting issues.

Remove the definition of GZIP, this adds three "lookups" of the `gzip`
binary but the rest of the build system doesn't seem to use such
improvements neither.

Signed-off-by: Paul Spooren <mail at aparcar.org>
---
 scripts/ipkg-build | 81 +++++++++++++++++++++++-----------------------
 1 file changed, 40 insertions(+), 41 deletions(-)

diff --git a/scripts/ipkg-build b/scripts/ipkg-build
index 343aab6caf..8533c97fcc 100755
--- a/scripts/ipkg-build
+++ b/scripts/ipkg-build
@@ -13,7 +13,6 @@ version=1.0
 FIND="$(command -v find)"
 FIND="${FIND:-$(command -v gfind)}"
 TAR="${TAR:-$(command -v tar)}"
-GZIP="$(command -v gzip)"
 
 # try to use fixed source epoch
 if [ -n "$PKG_SOURCE_DATE_EPOCH" ]; then
@@ -31,40 +30,40 @@ ipkg_extract_value() {
 required_field() {
 	field=$1
 
-	grep "^$field:" < $CONTROL/control | ipkg_extract_value
+	grep "^$field:" < "$CONTROL/control" | ipkg_extract_value
 }
 
 pkg_appears_sane() {
-	local pkg_dir=$1
+	local pkg_dir="$1"
 
-	local owd=$PWD
-	cd $pkg_dir
+	local owd="$PWD"
+	cd "$pkg_dir"
 
 	PKG_ERROR=0
-	pkg=`required_field Package`
-	version=`required_field Version | sed 's/Version://; s/^.://g;'`
-	arch=`required_field Architecture`
+	pkg="$(required_field Package)"
+	version="$(required_field Version | sed 's/Version://; s/^.://g;')"
+	arch="$(required_field Architecture)"
 
-	if echo $pkg | grep '[^a-zA-Z0-9_.+-]'; then
+	if echo "$pkg" | grep '[^a-zA-Z0-9_.+-]'; then
 		echo "*** Error: Package name $name contains illegal characters, (other than [a-z0-9.+-])" >&2
 		PKG_ERROR=1;
 	fi
 
-	if [ -f $CONTROL/conffiles ]; then
-		rm -f $CONTROL/conffiles.resolved
+	if [ -f "$CONTROL/conffiles" ]; then
+		rm -f "$CONTROL/conffiles.resolved"
 
-		for cf in `$FIND $(sed -e "s!^/!$pkg_dir/!" $CONTROL/conffiles) -type f`; do
-			echo "${cf#$pkg_dir}" >> $CONTROL/conffiles.resolved
+		for cf in $($FIND $(sed -e "s!^/!$pkg_dir/!" "$CONTROL/conffiles") -type f); do
+			echo "${cf#$pkg_dir}" >> "$CONTROL/conffiles.resolved"
 		done
 
-		rm $CONTROL/conffiles
-		if [ -f $CONTROL/conffiles.resolved ]; then
-			mv $CONTROL/conffiles.resolved $CONTROL/conffiles
-			chmod 0644 $CONTROL/conffiles
+		rm "$CONTROL"/conffiles
+		if [ -f "$CONTROL"/conffiles.resolved ]; then
+			mv "$CONTROL"/conffiles.resolved "$CONTROL"/conffiles
+			chmod 0644 "$CONTROL"/conffiles
 		fi
 	fi
 
-	cd $owd
+	cd "$owd"
 	return $PKG_ERROR
 }
 
@@ -95,17 +94,17 @@ file_modes=""
 usage="Usage: $0 [-v] [-h] [-m] <pkg_directory> [<destination_directory>]"
 while getopts "hvm:" opt; do
     case $opt in
-	v ) echo $version
+	v ) echo "$version"
 	    exit 0
 	    ;;
-	h ) 	echo $usage  >&2 ;;
+	h ) 	echo "$usage"  >&2 ;;
 	m )	file_modes=$OPTARG ;;
-	\? ) 	echo $usage  >&2
+	\? ) 	echo "$usage"  >&2
 	esac
 done
 
 
-shift $(($OPTIND - 1))
+shift $((OPTIND - 1))
 
 # continue on to process additional arguments
 
@@ -115,42 +114,42 @@ case $# in
 	;;
 2)
 	dest_dir=$2
-	if [ "$dest_dir" = "." -o "$dest_dir" = "./" ] ; then
+	if [ "$dest_dir" = "." ] || [ "$dest_dir" = "./" ] ; then
 	    dest_dir=$PWD
 	fi
 	;;
 *)
-	echo $usage >&2
+	echo "$usage" >&2
 	exit 1
 	;;
 esac
 
-pkg_dir=$1
+pkg_dir="$1"
 
-if [ ! -d $pkg_dir ]; then
+if [ ! -d "$pkg_dir" ]; then
 	echo "*** Error: Directory $pkg_dir does not exist" >&2
 	exit 1
 fi
 
 # CONTROL is second so that it takes precedence
 CONTROL=
-[ -d $pkg_dir/CONTROL ] && CONTROL=CONTROL
+[ -d "$pkg_dir"/CONTROL ] && CONTROL=CONTROL
 if [ -z "$CONTROL" ]; then
 	echo "*** Error: Directory $pkg_dir has no CONTROL subdirectory." >&2
 	exit 1
 fi
 
-if ! pkg_appears_sane $pkg_dir; then
+if ! pkg_appears_sane "$pkg_dir"; then
 	echo >&2
 	echo "ipkg-build: Please fix the above errors and try again." >&2
 	exit 1
 fi
 
 tmp_dir=$dest_dir/IPKG_BUILD.$$
-mkdir $tmp_dir
+mkdir "$tmp_dir"
 
-echo $CONTROL > $tmp_dir/tarX
-cd $pkg_dir
+echo $CONTROL > "$tmp_dir"/tarX
+cd "$pkg_dir"
 for file_mode in $file_modes; do
 	case $file_mode in
 	/*:*:*:*)
@@ -179,22 +178,22 @@ for file_mode in $file_modes; do
 	chown "$uid:$gid" "$pkg_dir/$path"
 	chmod  "$mode" "$pkg_dir/$path"
 done
-$TAR -X $tmp_dir/tarX --format=gnu --sort=name -cpf - --mtime="$TIMESTAMP" . | $GZIP -n - > $tmp_dir/data.tar.gz
+$TAR -X "$tmp_dir"/tarX --format=gnu --sort=name -cpf - --mtime="$TIMESTAMP" . | gzip -n - > "$tmp_dir"/data.tar.gz
 
-installed_size=`stat -c "%s" $tmp_dir/data.tar.gz`
+installed_size=$(stat -c "%s" "$tmp_dir"/data.tar.gz)
 sed -i -e "s/^Installed-Size: .*/Installed-Size: $installed_size/" \
-	$pkg_dir/$CONTROL/control
+	"$pkg_dir"/$CONTROL/control
 
-( cd $pkg_dir/$CONTROL && $TAR --format=gnu --sort=name -cf -  --mtime="$TIMESTAMP" . | $GZIP -n - > $tmp_dir/control.tar.gz )
-rm $tmp_dir/tarX
+( cd "$pkg_dir"/$CONTROL && $TAR --format=gnu --sort=name -cf -  --mtime="$TIMESTAMP" . | gzip -n - > "$tmp_dir"/control.tar.gz )
+rm "$tmp_dir"/tarX
 
-echo "2.0" > $tmp_dir/debian-binary
+echo "2.0" > "$tmp_dir"/debian-binary
 
 pkg_file=$dest_dir/${pkg}_${version}_${arch}.ipk
-rm -f $pkg_file
-( cd $tmp_dir && $TAR --format=gnu --sort=name -cf -  --mtime="$TIMESTAMP" ./debian-binary ./data.tar.gz ./control.tar.gz | $GZIP -n - > $pkg_file )
+rm -f "$pkg_file"
+( cd "$tmp_dir" && $TAR --format=gnu --sort=name -cf -  --mtime="$TIMESTAMP" ./debian-binary ./data.tar.gz ./control.tar.gz | gzip -n - > "$pkg_file" )
 
-rm $tmp_dir/debian-binary $tmp_dir/data.tar.gz $tmp_dir/control.tar.gz
-rmdir $tmp_dir
+rm "$tmp_dir"/debian-binary "$tmp_dir"/data.tar.gz "$tmp_dir"/control.tar.gz
+rmdir "$tmp_dir"
 
 echo "Packaged contents of $pkg_dir into $pkg_file"
-- 
2.30.0




More information about the openwrt-devel mailing list